//ReunirDocuments_403f.js
// 21.05.11 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//DESCRIPTION:Runir plusieurs documents en un seul

// activer l'affichage des dialogues
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// tester s'il y a un document ouvert
if (app.documents.length != 0) {
	alert ("Il faut fermer tous les documents.", "Attention");
	exit();
}

// slectionner un dossier
var selFolder = "/d/"
var folderObj = File (Folder.selectDialog("Slectionner le dossier contenant les documents InDesign.", selFolder));
var testObj = "" + folderObj;
if (testObj.match("null")) {
	exit();
}

// dresser une liste du contenu du dossier slectionn
var docsList = folderObj.getFiles("*.indd");

var probCtr = 0;

// dsactiver l'affichage des dialogues
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.neverInteract;
try {
	// ouvrir le premier fichier
	app.open(File(docsList[0]));
	// activer l'affichage des dialogues
	app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;
}
catch (e) {
	// dsactiver l'affichage des dialogues
	app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;
	alert ("Le premier fichier ne peut pas tre ouvert.", "Stop");
	exit();
}

// le premier document
var curDoc = app.documents[0];
// le chemin au dossier contenant le document
var docFolder = curDoc.filePath;
// le nom du document
var docName = curDoc.name.slice(0, -5);
var newName = docName + "x";

// composer le chemin
var fullPath = docFolder + "/" + newName + ".indd";

// vrifier s'il n'y a pas un fichier du mme
var fi = File(fullPath).exists; 
if (fi == true) {
	alert ("Attention: sortir le fichier\n\n" + newName + ".indd\n\ndu dossier et relancer le script.", "Stop");
	exit();
}

// mmoriser le genre (simple ou double)
var doublePage = curDoc.documentPreferences.facingPages;
if (doublePage) {
	// activer "Autoriser la rorganisation des pages"
	curDoc.documentPreferences.allowPageShuffle = true;
}
else {
	// dsactiver "Autoriser la rorganisation des pages"
	curDoc.documentPreferences.allowPageShuffle = false;
}

// enregistrer le fichier sous le nouveau nom
curDoc.save(new File(fullPath));

// dsactiver l'affichage des dialogues
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.neverInteract;

// une boucle  travers les autres documents
var diffVal;
var firstPage;
var lastPage;
var newDoc;
var nSpreads;
var pS;
var startPg;
for (var i=1; i<docsList.length; i++) {
	lastPage = (curDoc.pages.item(-1).name)*1;
	app.open(File(docsList[i]));
	newDoc = app.documents[0];
	firstPage = (newDoc.pages[0].name)*1;
	nSpreads = newDoc.spreads.length;
	diffVal = (firstPage - lastPage);
	
	if (diffVal != 1) {
		// dsactiver "Autoriser la rorganisation des pages"
		app.documents[1].documentPreferences.allowPageShuffle = false;
		// prparer la nouvelle page de dpart
		startPg = app.documents[0].pages[0].name;
		try {
			// copier la premire planche
			newDoc.spreads[0].duplicate(LocationOptions.after, app.documents[1].spreads[-1]);
			// dfinir un nouvelle section
			pS = app.documents[1].pages.item(startPg);
			curDoc.sections.add({pageStart:pS,continueNumbering:false, pageNumberStart:firstPage});
			// appeler la fonction qui supprime le prfixe de section
			delSect();
		}
		catch (e) {
			probCtr++;
		}
		
		if (nSpreads > 1) {
			for (var s=1; s<nSpreads; s++) {
				try {
					newDoc.spreads[s].duplicate(LocationOptions.after, app.documents[1].spreads[-1]);
				}
				catch (e) {
					probCtr++;
				}
				lastPage = (curDoc.pages.item(-1).name)*1;
				if (doublePage && (lastPage % 2 == 0)) {
					// activer "Autoriser la rorganisation des pages"
					curDoc.documentPreferences.allowPageShuffle = true;
				}
				else {
					// dsactiver "Autoriser la rorganisation des pages"
					curDoc.documentPreferences.allowPageShuffle = false;
				}
			}
		}
	}
	else {
		if (lastPage % 2 == 0) {
			// activer "Autoriser la rorganisation des pages"
			curDoc.documentPreferences.allowPageShuffle = true;
		}
		for (var s=0; s<nSpreads; s++) {
			try {
				newDoc.spreads[s].duplicate(LocationOptions.after, app.documents[1].spreads[-1]);
			}
			catch (e) {
				probCtr++;
			}
			lastPage = (curDoc.pages.item(-1).name)*1;
			if (doublePage && (lastPage % 2 == 0)) {
				// activer "Autoriser la rorganisation des pages"
				curDoc.documentPreferences.allowPageShuffle = true;
			}
			else {
				// dsactiver "Autoriser la rorganisation des pages"
				curDoc.documentPreferences.allowPageShuffle = false;
			}
		}
	}
	newDoc.close(SaveOptions.no);
}

// activer l'affichage des dialogues
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// annoncer la fin de l'action
if (probCtr == 0) {
	var dlog = new Window("palette");
	dlog.size = [320,100];
	dlog.add("statictext", [80, 100, 320, 116], "Termin, pas de problmes.");
	dlog.show();
	// une petite pause
	$.sleep(1500);
	// fermer la fentre
	dlog.close();
}
else if (probCtr == 1) {
	alert ("Une seule planche n'a pas pu tre insre.", "Attention");
}
else if (probCtr > 1) {
	alert ("" + probCtr + " planches n'ont pas pu tre insres.", "Attention");
}

// la fonction qui supprime des prfixes de section ventuels
// afin de pouvoir adresser les pages correctement
function delSect() {
	allSections = app.documents[0].sections;
	for (var i=0; i<allSections.length; i++) {
		try {
			allSections[i].sectionPrefix = "";
		}
		catch (e) {
		}
	}
}
